com.amazon.redshift.jdbc

## Class MetadataAPIPostProcessor

- java.lang.Object
- - com.amazon.redshift.jdbc.MetadataAPIHelper
  - - com.amazon.redshift.jdbc.MetadataAPIPostProcessor

    public class MetadataAPIPostProcessor
    extends MetadataAPIHelper

### Nested Class Summary

### Nested classes/interfaces inherited from class com.amazon.redshift.jdbc.MetadataAPIHelper

`MetadataAPIHelper.BestRowIdenData, MetadataAPIHelper.enumFunc<T extends Enum<T>>, MetadataAPIHelper.ForeignKeyColumnIndex, MetadataAPIHelper.GetBestRowIdentifier_Metadata, MetadataAPIHelper.GetCatalogs_Metadata, MetadataAPIHelper.GetColumnPrivileges_Metadata, MetadataAPIHelper.GetColumns_Metadata, MetadataAPIHelper.GetForeignKeys_Metadata, MetadataAPIHelper.GetFunctions_Metadata, MetadataAPIHelper.GetFunctionsColumns_Metadata, MetadataAPIHelper.GetPrimaryKeys_Metadata, MetadataAPIHelper.GetProcedures_Metadata, MetadataAPIHelper.GetProceduresColumns_Metadata, MetadataAPIHelper.GetSchemas_Metadata, MetadataAPIHelper.GetTablePrivileges_Metadata, MetadataAPIHelper.GetTables_Metadata, MetadataAPIHelper.GetTableType_Metadata, MetadataAPIHelper.ProcedureFunctionColumnData, MetadataAPIHelper.RedshiftDataTypes, MetadataAPIHelper.ShowColumnsInfo, MetadataAPIHelper.ShowForeignKeysInfo, MetadataAPIHelper.ShowFunctionsInfo, MetadataAPIHelper.ShowGrantsInfo, MetadataAPIHelper.ShowParametersInfo, MetadataAPIHelper.ShowPrimaryKeysInfo, MetadataAPIHelper.ShowProceduresInfo, MetadataAPIHelper.ShowSchemasInfo, MetadataAPIHelper.ShowTablesInfo`

### Field Summary

Fields
`protected RedshiftConnectionImpl` `connection`

### Fields inherited from class com.amazon.redshift.jdbc.MetadataAPIHelper

`DATETIME_PRECISION_PATTERN, EMPTY_REMARKS, FUNCTION_COLUMN_TYPE_MAP, GET_BEST_ROW_IDENTIFIER_COLS, GET_CATALOGS_COLS, GET_COLUMN_PRIVILEGES_COLS, GET_COLUMNS_COLS, GET_FOREIGN_KEYS_COLS, GET_FUNCTIONS_COLS, GET_FUNCTIONS_COLUMNS_COLS, GET_PRIMARY_KEYS_COLS, GET_PROCEDURES_COLS, GET_PROCEDURES_COLUMNS_COLS, GET_SCHEMAS_COLS, GET_TABLE_PRIVILEGES_COLS, GET_TABLE_TYPE_COLS, GET_TABLES_COLS, IMPORTED_KEY_NO_ACTION, IMPORTED_KEY_NOT_DEFERRABLE, INTERVAL_PRECISION_PATTERN, IS_NULLABLE_VALUE, NULLABLE_UNKNOWN_VALUE, PRECISION_EXTRACTION_PATTERN, PRECISION_REMOVAL_PATTERN, PROCEDURE_COLUMN_TYPE_MAP, PSEUDO_COLUMN_VALUE, RADIX_VALUE, SHOW_COLUMNS_CHARACTER_MAXIMUM_LENGTH, SHOW_COLUMNS_COLLATION, SHOW_COLUMNS_COLUMN_DEFAULT, SHOW_COLUMNS_COLUMN_NAME, SHOW_COLUMNS_DATA_TYPE, SHOW_COLUMNS_DATABASE_NAME, SHOW_COLUMNS_DIST_KEY, SHOW_COLUMNS_ENCODING, SHOW_COLUMNS_IS_NULLABLE, SHOW_COLUMNS_NUMERIC_PRECISION, SHOW_COLUMNS_NUMERIC_SCALE, SHOW_COLUMNS_ORDINAL_POSITION, SHOW_COLUMNS_REMARKS, SHOW_COLUMNS_SCHEMA_NAME, SHOW_COLUMNS_SORT_KEY, SHOW_COLUMNS_SORT_KEY_TYPE, SHOW_COLUMNS_TABLE_NAME, SHOW_DATABASES_DATABASE_NAME, SHOW_FOREIGN_KEYS_DEFERRABILITY, SHOW_FOREIGN_KEYS_DELETE_RULE, SHOW_FOREIGN_KEYS_FK_COLUMN_NAME, SHOW_FOREIGN_KEYS_FK_DATABASE_NAME, SHOW_FOREIGN_KEYS_FK_NAME, SHOW_FOREIGN_KEYS_FK_SCHEMA_NAME, SHOW_FOREIGN_KEYS_FK_TABLE_NAME, SHOW_FOREIGN_KEYS_KEY_SEQ, SHOW_FOREIGN_KEYS_PK_COLUMN_NAME, SHOW_FOREIGN_KEYS_PK_DATABASE_NAME, SHOW_FOREIGN_KEYS_PK_NAME, SHOW_FOREIGN_KEYS_PK_SCHEMA_NAME, SHOW_FOREIGN_KEYS_PK_TABLE_NAME, SHOW_FOREIGN_KEYS_UPDATE_RULE, SHOW_FUNCTIONS_ARGUMENT_LIST, SHOW_FUNCTIONS_DATABASE_NAME, SHOW_FUNCTIONS_FUNCTION_NAME, SHOW_FUNCTIONS_RETURN_TYPE, SHOW_FUNCTIONS_SCHEMA_NAME, SHOW_GRANT_ADMIN_OPTION, SHOW_GRANT_COLUMN_NAME, SHOW_GRANT_DATABASE_NAME, SHOW_GRANT_GRANTOR, SHOW_GRANT_IDENTITY_NAME, SHOW_GRANT_OBJECT_NAME, SHOW_GRANT_PRIVILEGE_TYPE, SHOW_GRANT_SCHEMA_NAME, SHOW_GRANT_TABLE_NAME, SHOW_PARAMETERS_CHARACTER_MAXIMUM_LENGTH, SHOW_PARAMETERS_DATA_TYPE, SHOW_PARAMETERS_DATABASE_NAME, SHOW_PARAMETERS_FUNCTION_NAME, SHOW_PARAMETERS_NUMERIC_PRECISION, SHOW_PARAMETERS_NUMERIC_SCALE, SHOW_PARAMETERS_ORDINAL_POSITION, SHOW_PARAMETERS_PARAMETER_NAME, SHOW_PARAMETERS_PARAMETER_TYPE, SHOW_PARAMETERS_PROCEDURE_NAME, SHOW_PARAMETERS_SCHEMA_NAME, SHOW_PRIMARY_KEYS_COLUMN_NAME, SHOW_PRIMARY_KEYS_DATABASE_NAME, SHOW_PRIMARY_KEYS_KEY_SEQ, SHOW_PRIMARY_KEYS_PK_NAME, SHOW_PRIMARY_KEYS_SCHEMA_NAME, SHOW_PRIMARY_KEYS_TABLE_NAME, SHOW_PROCEDURES_ARGUMENT_LIST, SHOW_PROCEDURES_DATABASE_NAME, SHOW_PROCEDURES_PROCEDURE_NAME, SHOW_PROCEDURES_RETURN_TYPE, SHOW_PROCEDURES_SCHEMA_NAME, SHOW_SCHEMAS_DATABASE_NAME, SHOW_SCHEMAS_SCHEMA_NAME, SHOW_TABLES_DATABASE_NAME, SHOW_TABLES_DIST_STYLE, SHOW_TABLES_LAST_ALTERED_TIME, SHOW_TABLES_LAST_MODIFIED_TIME, SHOW_TABLES_OWNER, SHOW_TABLES_REMARKS, SHOW_TABLES_SCHEMA_NAME, SHOW_TABLES_TABLE_NAME, SHOW_TABLES_TABLE_SUBTYPE, SHOW_TABLES_TABLE_TYPE, SQL_LIKE, SQL_PREP_SHOWCOLUMNS, SQL_PREP_SHOWCOLUMNSLIKE, SQL_PREP_SHOWDATABASES, SQL_PREP_SHOWFOREIGNEXPORTEDKEYS, SQL_PREP_SHOWFOREIGNKEYS, SQL_PREP_SHOWFUNCTIONS, SQL_PREP_SHOWFUNCTIONSLIKE, SQL_PREP_SHOWGRANTSCOLUMN, SQL_PREP_SHOWGRANTSCOLUMNLIKE, SQL_PREP_SHOWGRANTSTABLE, SQL_PREP_SHOWPARAMETERSFUNCTION, SQL_PREP_SHOWPARAMETERSPROCEDURE, SQL_PREP_SHOWPRIMARYKEYS, SQL_PREP_SHOWPROCEDURES, SQL_PREP_SHOWPROCEDURESLIKE, SQL_PREP_SHOWSCHEMAS, SQL_PREP_SHOWSCHEMASLIKE, SQL_PREP_SHOWTABLES, SQL_PREP_SHOWTABLESLIKE, SQL_SEMICOLON, TRAILING_SPACES_PATTERN`

### Constructor Summary

Constructors
Constructor and Description
`MetadataAPIPostProcessor(RedshiftConnectionImpl connection)`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected ResultSet` `getBestRowIdentifierPostProcessing(List<MetadataAPIHelper.BestRowIdenData> serverResultSets, int scope)`
`protected ResultSet` `getCatalogsPostProcessing(List<String> serverResults)`
`protected ResultSet` `getColumnPrivilegesPostProcessing(List<MetadataAPIHelper.ShowGrantsInfo> serverResultSets, String columnPattern)`
`protected ResultSet` `getColumnsPostProcessing(List<MetadataAPIHelper.ShowColumnsInfo> serverResultSets)`
`protected ResultSet` `getForeignKeysPostProcessing(List<MetadataAPIHelper.ShowForeignKeysInfo> serverResultSets, boolean isImported)`
`protected ResultSet` `getFunctionColumnsPostProcessing(List<MetadataAPIHelper.ProcedureFunctionColumnData> serverResultSets)`
`protected ResultSet` `getFunctionsPostProcessing(List<MetadataAPIHelper.ShowFunctionsInfo> serverResultSets)`
`protected ResultSet` `getPrimaryKeysPostProcessing(List<MetadataAPIHelper.ShowPrimaryKeysInfo> serverResultSets)`
`protected ResultSet` `getProcedureColumnsPostProcessing(List<MetadataAPIHelper.ProcedureFunctionColumnData> serverResultSets)`
`protected ResultSet` `getProceduresPostProcessing(List<MetadataAPIHelper.ShowProceduresInfo> serverResultSets)`
`protected ResultSet` `getSchemasPostProcessing(List<MetadataAPIHelper.ShowSchemasInfo> serverResultSets)`
`protected ResultSet` `getTablePrivilegesPostProcessing(List<MetadataAPIHelper.ShowGrantsInfo> serverResultSets)`
`protected ResultSet` `getTablesPostProcessing(List<MetadataAPIHelper.ShowTablesInfo> serverResultSets, String[] types)`
`protected ResultSet` `getTableTypesPostProcessing(ResultSet serverResultSet)`

### Methods inherited from class com.amazon.redshift.jdbc.MetadataAPIHelper

`convertSqlLikeToRegex, createMetaDataPreparedStatement, createMetaDataStatement, createParameterizedQueryString, createRs, encodeStr, getAutoIncrement, getColumnLength, getColumnSize, getDecimalDigit, getEmptyTuple, getField, getFunctionColumnType, getFunctionType, getIsGrantable, getNullable, getNumPrefixRadix, getProcedureColumnType, getProcedureType, getRSType, getSpecificName, getSQLType, patternMatch, runQuery, sortForeignKeyTuples`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### connection

    protected final RedshiftConnectionImpl connection

### Constructor Detail

#### MetadataAPIPostProcessor

    public MetadataAPIPostProcessor(RedshiftConnectionImpl connection)

### Method Detail

#### getCatalogsPostProcessing

    protected ResultSet getCatalogsPostProcessing(List<String> serverResults)
                                           throws SQLException

Throws:
  `SQLException`

#### getSchemasPostProcessing

    protected ResultSet getSchemasPostProcessing(List<MetadataAPIHelper.ShowSchemasInfo> serverResultSets)
                                          throws SQLException

Throws:
  `SQLException`

#### getTablesPostProcessing

    protected ResultSet getTablesPostProcessing(List<MetadataAPIHelper.ShowTablesInfo> serverResultSets,
                                                String[] types)
                                         throws SQLException

Throws:
  `SQLException`

#### getColumnsPostProcessing

    protected ResultSet getColumnsPostProcessing(List<MetadataAPIHelper.ShowColumnsInfo> serverResultSets)
                                          throws SQLException

Throws:
  `SQLException`

#### getPrimaryKeysPostProcessing

    protected ResultSet getPrimaryKeysPostProcessing(List<MetadataAPIHelper.ShowPrimaryKeysInfo> serverResultSets)
                                              throws SQLException

Throws:
  `SQLException`

#### getForeignKeysPostProcessing

    protected ResultSet getForeignKeysPostProcessing(List<MetadataAPIHelper.ShowForeignKeysInfo> serverResultSets,
                                                     boolean isImported)
                                              throws SQLException

Throws:
  `SQLException`

#### getBestRowIdentifierPostProcessing

    protected ResultSet getBestRowIdentifierPostProcessing(List<MetadataAPIHelper.BestRowIdenData> serverResultSets,
                                                           int scope)
                                                    throws SQLException

Throws:
  `SQLException`

#### getTableTypesPostProcessing

    protected ResultSet getTableTypesPostProcessing(ResultSet serverResultSet)
                                             throws SQLException

Throws:
  `SQLException`

#### getColumnPrivilegesPostProcessing

    protected ResultSet getColumnPrivilegesPostProcessing(List<MetadataAPIHelper.ShowGrantsInfo> serverResultSets,
                                                          String columnPattern)
                                                   throws SQLException

Throws:
  `SQLException`

#### getTablePrivilegesPostProcessing

    protected ResultSet getTablePrivilegesPostProcessing(List<MetadataAPIHelper.ShowGrantsInfo> serverResultSets)
                                                  throws SQLException

Throws:
  `SQLException`

#### getProceduresPostProcessing

    protected ResultSet getProceduresPostProcessing(List<MetadataAPIHelper.ShowProceduresInfo> serverResultSets)
                                             throws SQLException

Throws:
  `SQLException`

#### getProcedureColumnsPostProcessing

    protected ResultSet getProcedureColumnsPostProcessing(List<MetadataAPIHelper.ProcedureFunctionColumnData> serverResultSets)
                                                   throws SQLException

Throws:
  `SQLException`

#### getFunctionsPostProcessing

    protected ResultSet getFunctionsPostProcessing(List<MetadataAPIHelper.ShowFunctionsInfo> serverResultSets)
                                            throws SQLException

Throws:
  `SQLException`

#### getFunctionColumnsPostProcessing

    protected ResultSet getFunctionColumnsPostProcessing(List<MetadataAPIHelper.ProcedureFunctionColumnData> serverResultSets)
                                                  throws SQLException

Throws:
  `SQLException`